Attribute VB_Name = "modHandleText"
'**********************************************
'* Handle correct text display in every view: *
'**********************************************

'A 96-pixel tall glyph is 72 points because each point is about 1/72 of an inch. This means each pixel is 72/96 point or 0.75 point per pixel.
' => Font size in Windows with monitor resolution 96dpi is always rounded to 0.75pt (for other monitor resolutions: 72/iResolution): ..., 8.25, 9, 9.75, 10.5, 11.25, 12, ...
' => Make sure soft return positions are the same in every view (so for every font size) by adding spaces

Option Explicit

Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90

Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "GDI32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

Private Declare Function CreateRectRgn Lib "GDI32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long

Public Sub HandleText(ByRef oRTB As RichTextBox, ByRef oElem As MSXML.IXMLDOMElement, ByVal bThumb As Boolean, ByVal Zoom As Single)

  On Error GoTo Error_Handler
  
  If bThumb Then 'Don't show text because not accurate and PrintWindow ignores these texts mostly anyway...
  
'    oRTB.Text = GetSoftReturnTags(XMLToString(oElem.Text))
'    oRTB.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & GetSoftReturnTags(XMLToString(oElem.Text))
'    oRTB.Font.Underline = oElem.getAttribute("UNDERLINE")
'    On Error Resume Next
'    oRTB.Font.Name = oElem.getAttribute("FONT")
'    If (iPgWdMm <> 0) And (oElem.getAttribute("WIDTH") <> 0) And (iPgWdTw <> 0) Then oRTB.Font.Size = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2) * oRTB.Width / (MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw)
'    On Error GoTo Error_Handler
    
'    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
    
'      oRTB.Font.Bold = True
'      oRTB.Font.Italic = True
      
'    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
    
'      oRTB.Font.Bold = True
'      oRTB.Font.Italic = False
      
'    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
    
'      oRTB.Font.Bold = False
'      oRTB.Font.Italic = True
      
'    Else
    
'      oRTB.Font.Bold = False
'      oRTB.Font.Italic = False
      
'    End If
    
'    oRTB.SelStart = 0
'    oRTB.SelLength = Len(oRTB.Text)
'    oRTB.SelColor = RGB2VB(oElem.getAttribute("COLOR"))
    
'    If oElem.getAttribute("HALIGN") = "LEFT" Then
    
'      oRTB.SelAlignment = rtfLeft
      
'    ElseIf oElem.getAttribute("HALIGN") = "RIGHT" Then
    
'      oRTB.SelAlignment = rtfRight
      
'    ElseIf oElem.getAttribute("HALIGN") = "CENTER" Then
    
'      oRTB.SelAlignment = rtfCenter
      
'    ElseIf oElem.getAttribute("HALIGN") = "JUSTIFY" Then
    
'      crt.Justify oRTB.hwnd, 0, Len(oRTB.Text)
'      SetAlignment oRTB.hwnd, ercParaJustify
      
'    End If
    
'    oRTB.SelLength = 0
'    oRTB.Visible = True
'    oRTB.ZOrder 0
    
  Else
  
    Dim sText       As String  'Contains the text to display
    Dim iResolution As Integer 'Monitor resolution (normally 96dpi)
    
    sText = GetSoftReturnTags(XMLToString(oElem.Text))
    iResolution = GetDeviceCaps(GetDC(0), LOGPIXELSX)
    
    'Create real size RTB:
    
    If frmPixbook.TabStrip1.SelectedItem.Key = "tab1" Or (frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) <= 2) Then
    
      frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
      frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
      
    ElseIf frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
    
      frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
      frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
      
    ElseIf frmPixbook.TabStrip1.SelectedItem.Key = "tab2" Then
    
      If iPgWd <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oRTB.Width / iPgWd / Zoom
      If iPgHt <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oRTB.Height / iPgHt / Zoom
      
    ElseIf CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
    
      If iPgWd <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oRTB.Width / iPgWd / Zoom
      If iPgHt <> 0 And Zoom <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oRTB.Height / iPgHt / Zoom
      
    End If
    
    frmAbout.RealSizeRTB.Text = sText
    If Len(oElem.getAttribute("SIZE")) >= 2 Then frmAbout.RealSizeRTB.Font.Size = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2)
    
    'Prepare oRTB:
    
    oRTB.Visible = False
    oRTB.Text = sText
    oRTB.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & sText
    On Error Resume Next
    oRTB.Font.Name = oElem.getAttribute("FONT")
    On Error GoTo Error_Handler
    oRTB.Font.Size = frmAbout.RealSizeRTB.Font.Size * oRTB.Width / frmAbout.RealSizeRTB.Width
    oRTB.Font.Size = oRTB.Font.Size + 2 * 72 / iResolution 'Start with largest font possible, then reduce font size if necessary
    
    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
    
      oRTB.Font.Bold = True
      oRTB.Font.Italic = True
      
    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
    
      oRTB.Font.Bold = True
      oRTB.Font.Italic = False
      
    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
    
      oRTB.Font.Bold = False
      oRTB.Font.Italic = True
      
    Else
    
      oRTB.Font.Bold = False
      oRTB.Font.Italic = False
      
    End If
    
    oRTB.Font.Underline = oElem.getAttribute("UNDERLINE")
    
    'Set RealSizeRTB tag with soft return positions:
    
    frmAbout.RealSizeRTB.Font.Name = oRTB.Font.Name
    frmAbout.RealSizeRTB.Font.Bold = oRTB.Font.Bold
    frmAbout.RealSizeRTB.Font.Italic = oRTB.Font.Italic
    frmAbout.RealSizeRTB.Font.Underline = oRTB.Font.Underline
    
    Dim iPos As Integer
    Dim sTag As String
    
    For iPos = 1 To Len(frmAbout.RealSizeRTB.Text) - 1
    
      If frmAbout.RealSizeRTB.GetLineFromChar(iPos + 1) <> frmAbout.RealSizeRTB.GetLineFromChar(iPos) Then sTag = sTag & iPos + 1 & ","
      
    Next
    
    frmAbout.RealSizeRTB.Tag = sTag 'Exact positions of the soft returns
    
    'Get real size RTB parameters:
    
    Dim OriLines As Integer 'Real size RTB number of lines
    Dim OriChars As Integer 'Real size RTB number of chars on last line
    
    OriLines = frmAbout.RealSizeRTB.GetLineFromChar(Len(frmAbout.RealSizeRTB.Text))
    OriChars = GetNumberOfCharsOnLastLine(frmAbout.RealSizeRTB)
    
    'Reduce font size if necessary so we can add spaces in tag positions to simulate soft returns:
    
Retry:
    If oRTB.GetLineFromChar(Len(oRTB.Text)) > OriLines Or (oRTB.GetLineFromChar(Len(oRTB.Text)) = OriLines And GetNumberOfCharsOnLastLine(oRTB) > OriChars) Or SmallerSoftReturnPositions(oRTB) Then
    
      oRTB.Font.Size = oRTB.Font.Size - 72 / iResolution
      GoTo Retry
      
    End If
    
    Dim i As Integer
    Dim j As Integer
    
    sTag = frmAbout.RealSizeRTB.Tag
    
    'Add spaces in tag positions to simulate soft returns:
    
    Do While sTag <> vbNullString
    
      i = 0
      iPos = CInt(Left(sTag, InStr(sTag, ",") - 1)) + j
      
      Do While oRTB.GetLineFromChar(iPos - 1) = oRTB.GetLineFromChar(iPos + i)
      
        oRTB.Text = Left(oRTB.Text, iPos - 1) & " " & mid(oRTB.Text, iPos)
        i = i + 1
        
      Loop
      
      sTag = mid(sTag, InStr(sTag, ",") + 1)
      j = j + i
      
    Loop
    
    'Finish oRTB (color & alignment):
    
    oRTB.SelStart = 0
    oRTB.SelLength = Len(oRTB.Text)
    oRTB.SelColor = RGB2VB(oElem.getAttribute("COLOR"))
    
    If oRTB.SelColor = vbWhite Then
    
      oRTB.BackColor = vbBlack
      
    Else
    
      oRTB.BackColor = vbWhite
      
    End If
    
    If oElem.getAttribute("HALIGN") = "LEFT" Then
    
      oRTB.SelAlignment = rtfLeft
      
    ElseIf oElem.getAttribute("HALIGN") = "RIGHT" Then
    
      oRTB.SelAlignment = rtfRight
      
    ElseIf oElem.getAttribute("HALIGN") = "CENTER" Then
    
      oRTB.SelAlignment = rtfCenter
      
    ElseIf oElem.getAttribute("HALIGN") = "JUSTIFY" Then
    
'      crt.Justify oRTB.hwnd, 0, Len(oRTB.Text)
      SetAlignment oRTB.hWnd, ercParaJustify
      
    End If
    
    oRTB.SelLength = 0
    oRTB.Visible = True
    oRTB.ZOrder 0
    
  End If
  
  Exit Sub
  
Error_Handler:
  HandleError Err, "modHandleText:HandleText", Erl
  Resume Next
  
End Sub

Public Sub HandleRotatedText(ByRef oPic As PictureBox, ByRef oElem As MSXML.IXMLDOMElement, ByVal bThumb As Boolean, ByVal Zoom As Single)

  On Error GoTo Error_Handler
  
  If bThumb Then 'Don't show text because not accurate and PrintWindow ignores these texts mostly anyway...
  
'    oPic.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & GetSoftReturnTags(XMLToString(oElem.Text))
'    On Error Resume Next
'    oPic.FontName = oElem.getAttribute("FONT")
'    If (iPgWdMm <> 0) And (oElem.getAttribute("WIDTH") <> 0) And (iPgWdTw <> 0) Then oPic.fontSize = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2) * oPic.Width / (MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw)
'    On Error GoTo Error_Handler
    
'    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
    
'      oPic.FontBold = True
'      oPic.FontItalic = True
      
'    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
    
'      oPic.FontBold = True
'      oPic.FontItalic = False
      
'    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
    
'      oPic.FontBold = False
'      oPic.FontItalic = True
      
'    Else
    
'      oPic.FontBold = False
'      oPic.FontItalic = False
      
'    End If
    
'    oPic.FontUnderline = oElem.getAttribute("UNDERLINE")
'    oPic.ForeColor = RGB2VB(oElem.getAttribute("COLOR"))
    
'    If oPic.ForeColor = vbWhite Then
    
'      oPic.BackColor = vbBlack
      
'    Else
    
'      oPic.BackColor = vbWhite
      
'    End If
    
'    PrintRotatedText oPic, GetSoftReturnTags(XMLToString(oElem.Text)), oElem.getAttribute("ROTATION"), oElem.getAttribute("HALIGN")
'    oPic.Visible = True
'    oPic.ZOrder 0
    
  Else
  
    Dim sText       As String  'Contains the text to display
    Dim iResolution As Integer 'Monitor resolution (normally 96dpi)
    
    sText = GetSoftReturnTags(XMLToString(oElem.Text))
    iResolution = GetDeviceCaps(GetDC(0), LOGPIXELSX)
    
    'Create real size RTB:
    
    If frmPixbook.TabStrip1.SelectedItem.Key = "tab1" Or (frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) <= 2) Then
    
      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
      
        frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
        frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
        
      Else '+/-90 or +/-270
      
        frmAbout.RealSizeRTB.Width = MM2TW * iPgHtMm * oElem.getAttribute("HEIGHT") / iPgHtTw
        frmAbout.RealSizeRTB.Height = MM2TW * iPgWdMm * oElem.getAttribute("WIDTH") / iPgWdTw
        
      End If
      
    ElseIf frmPrintPreview.Visible And CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
    
      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
      
        frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
        frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
        
      Else '+/-90 or +/-270
      
        frmAbout.RealSizeRTB.Width = MM2TW * iCvrHtMm * oElem.getAttribute("HEIGHT") / iCvrHtTw
        frmAbout.RealSizeRTB.Height = MM2TW * iCvrWdMm * oElem.getAttribute("WIDTH") / iCvrWdTw
        
      End If
      
    ElseIf frmPixbook.TabStrip1.SelectedItem.Key = "tab2" Then
    
      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
      
        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgWdMm * oPic.Width / iPgWd / Zoom
        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgHtMm * oPic.Height / iPgHt / Zoom
        
      Else '+/-90 or +/-270
      
        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iPgHtMm * oPic.Height / iPgHt / Zoom
        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iPgWdMm * oPic.Width / iPgWd / Zoom
        
      End If
      
    ElseIf CInt(Right(frmPixbook.TabStrip1.SelectedItem.Key, 1)) > 2 Then
    
      If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
      
        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrWdMm * oPic.Width / iPgWd / Zoom
        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrHtMm * oPic.Height / iPgHt / Zoom
        
      Else '+/-90 or +/-270
      
        If iPgHt <> 0 Then frmAbout.RealSizeRTB.Width = MM2TW * iCvrHtMm * oPic.Height / iPgHt / Zoom
        If iPgWd <> 0 Then frmAbout.RealSizeRTB.Height = MM2TW * iCvrWdMm * oPic.Width / iPgWd / Zoom
        
      End If
      
    End If
    
    frmAbout.RealSizeRTB.Text = sText
    If Len(oElem.getAttribute("SIZE")) >= 2 Then frmAbout.RealSizeRTB.Font.Size = Left(oElem.getAttribute("SIZE"), Len(oElem.getAttribute("SIZE")) - 2)
    
    'Prepare frmAbout.RotatedRTB:
    
    If oElem.getAttribute("ROTATION") = "180" Or oElem.getAttribute("ROTATION") = "-180" Then
    
      frmAbout.RotatedRTB.Width = oPic.Width
      frmAbout.RotatedRTB.Height = oPic.Height
      
    Else '+/-90 or +/-270
    
      frmAbout.RotatedRTB.Width = oPic.Height
      frmAbout.RotatedRTB.Height = oPic.Width
      
    End If
    
    frmAbout.RotatedRTB.Text = sText
    On Error Resume Next
    frmAbout.RotatedRTB.Font.Name = oElem.getAttribute("FONT")
    On Error GoTo Error_Handler
    frmAbout.RotatedRTB.Font.Size = frmAbout.RealSizeRTB.Font.Size * frmAbout.RotatedRTB.Width / frmAbout.RealSizeRTB.Width
    frmAbout.RotatedRTB.Font.Size = frmAbout.RotatedRTB.Font.Size + 2 * 72 / iResolution 'Start with largest font possible, then reduce font size if necessary
    
    If oElem.getAttribute("EMPH") = "BOLDITALIC" Then
    
      frmAbout.RotatedRTB.Font.Bold = True
      frmAbout.RotatedRTB.Font.Italic = True
      
    ElseIf oElem.getAttribute("EMPH") = "BOLD" Then
    
      frmAbout.RotatedRTB.Font.Bold = True
      frmAbout.RotatedRTB.Font.Italic = False
      
    ElseIf oElem.getAttribute("EMPH") = "ITALIC" Then
    
      frmAbout.RotatedRTB.Font.Bold = False
      frmAbout.RotatedRTB.Font.Italic = True
      
    Else
    
      frmAbout.RotatedRTB.Font.Bold = False
      frmAbout.RotatedRTB.Font.Italic = False
      
    End If
    
    frmAbout.RotatedRTB.Font.Underline = oElem.getAttribute("UNDERLINE")
    
    'Set RealSizeRTB tag with soft return positions:
    
    frmAbout.RealSizeRTB.Font.Name = frmAbout.RotatedRTB.Font.Name
    frmAbout.RealSizeRTB.Font.Bold = frmAbout.RotatedRTB.Font.Bold
    frmAbout.RealSizeRTB.Font.Italic = frmAbout.RotatedRTB.Font.Italic
    frmAbout.RealSizeRTB.Font.Underline = frmAbout.RotatedRTB.Font.Underline
    
    Dim iPos As Integer
    Dim sTag As String
    
    For iPos = 1 To Len(frmAbout.RealSizeRTB.Text) - 1
    
      If frmAbout.RealSizeRTB.GetLineFromChar(iPos + 1) <> frmAbout.RealSizeRTB.GetLineFromChar(iPos) Then sTag = sTag & iPos + 1 & ","
      
    Next
    
    frmAbout.RealSizeRTB.Tag = sTag 'Exact positions of the soft returns
    
    'Get real size RTB parameters:
    
    Dim OriLines As Integer 'Real size RTB number of lines
    Dim OriChars As Integer 'Real size RTB number of chars on last line
    
    OriLines = frmAbout.RealSizeRTB.GetLineFromChar(Len(frmAbout.RealSizeRTB.Text))
    OriChars = GetNumberOfCharsOnLastLine(frmAbout.RealSizeRTB)
    
    'Reduce font size if necessary so we can add spaces in tag positions to simulate soft returns:
    
Retry:
    If frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text)) > OriLines Or (frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text)) = OriLines And GetNumberOfCharsOnLastLine(frmAbout.RotatedRTB) > OriChars) Or SmallerSoftReturnPositions(frmAbout.RotatedRTB) Then
    
      frmAbout.RotatedRTB.Font.Size = frmAbout.RotatedRTB.Font.Size - 72 / iResolution
      GoTo Retry
      
    End If
    
    Dim i As Integer
    Dim j As Integer
    
    sTag = frmAbout.RealSizeRTB.Tag
    
    'Add spaces in tag positions to simulate soft returns: !!! NOT USABLE BECAUSE DIFFERENT TEXT SETTING RESULTS RTB <-> PICBOX !!!
    
'    Do While sTag <> vbNullString
    
'      i = 0
'      iPos = CInt(Left(sTag, InStr(sTag, ",") - 1)) + j
      
'      Do While frmAbout.RotatedRTB.GetLineFromChar(iPos - 1) = frmAbout.RotatedRTB.GetLineFromChar(iPos + i)
      
'        frmAbout.RotatedRTB.Text = Left(frmAbout.RotatedRTB.Text, iPos - 1) & " " & mid(frmAbout.RotatedRTB.Text, iPos)
'        i = i + 1
        
'      Loop
      
'      sTag = mid(sTag, InStr(sTag, ",") + 1)
'      j = j + i
      
'    Loop
    
    'Finish oPic:
    
    oPic.Tag = oElem.getAttribute("HALIGN") & "|" & oElem.getAttribute("ROTATION") & "#" & GetSoftReturnTags(XMLToString(oElem.Text))
    oPic.FontName = frmAbout.RotatedRTB.Font.Name
    oPic.fontSize = frmAbout.RotatedRTB.Font.Size
    oPic.FontBold = frmAbout.RotatedRTB.Font.Bold
    oPic.FontItalic = frmAbout.RotatedRTB.Font.Italic
    oPic.FontUnderline = frmAbout.RotatedRTB.Font.Underline
    oPic.ForeColor = RGB2VB(oElem.getAttribute("COLOR"))
    
    If oPic.ForeColor = vbWhite Then
    
      oPic.BackColor = vbBlack
      
    Else
    
      oPic.BackColor = vbWhite
      
    End If
    
    PrintRotatedText oPic, frmAbout.RotatedRTB.Text, oElem.getAttribute("ROTATION"), oElem.getAttribute("HALIGN")
    oPic.Visible = True
    oPic.ZOrder 0
    
  End If
  
  Exit Sub
  
Error_Handler:
  HandleError Err, "modHandleText:HandleRotatedText", Erl
  Resume Next
  
End Sub

Public Function HandleResizedText(ByRef oRTB As RichTextBox) As Boolean

  On Error GoTo Error_Handler
  oRTB.Visible = False
  oRTB.SelStart = 0
  oRTB.SelLength = 1 '1 is enough, otherwise problems with soft/hard returns
'  oRTB.SelLength = Len(oRTB.Text)
  
  'Prepare frmAbout.picText:
  
  frmAbout.picText.Font.Size = oRTB.SelFontSize
  frmAbout.picText.Font.Name = oRTB.SelFontName
  frmAbout.picText.Font.Bold = oRTB.SelBold
  frmAbout.picText.Font.Italic = oRTB.SelItalic
  frmAbout.picText.Font.Underline = oRTB.SelUnderline
  
  Dim bLarger As Boolean
  
  If frmPixbook.picDyn.ScaleWidth > oRTB.Width Or frmPixbook.picDyn.ScaleHeight > oRTB.Height Then bLarger = True '=> no limitations
  
  'First test on total TextHeight and TextWidth of first character:
  
  If bLarger Or (frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY And frmAbout.picText.TextWidth(oRTB.SelText) <= frmPixbook.picDyn.ScaleWidth / iTwX) Then
  
    Dim lPrevWidth  As Long
    Dim lPrevHeight As Long
    Dim hRegion     As Long
    
    lPrevWidth = oRTB.Width
    lPrevHeight = oRTB.Height
    oRTB.Width = frmPixbook.picDyn.ScaleWidth
    oRTB.Height = frmPixbook.picDyn.ScaleHeight
    
    'Changing the text width may affect total TextHeight => second test:
    
    If bLarger Or frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY Then
    
      hRegion = CreateRectRgn(0, 0, oRTB.Width / iTwX, oRTB.Height / iTwY)
      SetWindowRgn oRTB.hWnd, hRegion, 1
      DeleteObject hRegion
      HandleResizedText = True
      
    Else
    
      oRTB.Width = lPrevWidth
      oRTB.Height = lPrevHeight
      
    End If
    
  End If
  
  oRTB.SelLength = 0
  oRTB.Visible = True
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedText", Erl
  Resume Next
  
End Function

Public Function HandleResizedTextFrame(ByRef oRTB As RichTextBox, ByRef oFrame As PictureBox) As Boolean

  On Error GoTo Error_Handler
  oRTB.Visible = False
  oRTB.SelStart = 0
  oRTB.SelLength = 1 '1 is enough, otherwise problems with soft/hard returns
'  oRTB.SelLength = Len(oRTB.Text)
  
  'Prepare frmAbout.picText:
  
  frmAbout.picText.Font.Size = oRTB.SelFontSize
  frmAbout.picText.Font.Name = oRTB.SelFontName
  frmAbout.picText.Font.Bold = oRTB.SelBold
  frmAbout.picText.Font.Italic = oRTB.SelItalic
  frmAbout.picText.Font.Underline = oRTB.SelUnderline
  
  Dim bLarger As Boolean
  
  If frmPixbook.picDyn.ScaleWidth > oFrame.Width Or frmPixbook.picDyn.ScaleHeight > oFrame.Height Then bLarger = True '=> no limitations
  
  'First test on total TextHeight and TextWidth of first character:
  
  If bLarger Or (frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY And frmAbout.picText.TextWidth(oRTB.SelText) <= frmPixbook.picDyn.ScaleWidth / iTwX) Then
  
    Dim lPrevWidth  As Long
    Dim lPrevHeight As Long
    Dim hRegion     As Long
    
    lPrevWidth = oRTB.Width
    lPrevHeight = oRTB.Height
    If oRTB.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width > 0 Then oRTB.Width = oRTB.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width
    If oRTB.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height > 0 Then oRTB.Height = oRTB.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height
    
    'Changing the text width may affect total TextHeight => second test:
    
    If bLarger Or frmAbout.picText.TextHeight(oRTB.SelText) * (1 + oRTB.GetLineFromChar(Len(oRTB.Text))) <= frmPixbook.picDyn.ScaleHeight / iTwY Then
    
      hRegion = CreateRectRgn(0, 0, oRTB.Width / iTwX, oRTB.Height / iTwY)
      SetWindowRgn oRTB.hWnd, hRegion, 1
      DeleteObject hRegion
      If oFrame.Tag = "0" Then SetWindowRgn oFrame.hWnd, 0, 1
      HandleResizedTextFrame = True
      
    Else
    
      oRTB.Width = lPrevWidth
      oRTB.Height = lPrevHeight
      
    End If
    
  End If
  
  oRTB.SelLength = 0
  oRTB.Visible = True
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedTextFrame", Erl
  Resume Next
  
End Function

Public Function HandleResizedRotatedText(ByRef oPic As PictureBox) As Boolean

  On Error GoTo Error_Handler
  
  'Prepare frmAbout.RotatedRTB:
  
  Dim lScaleWidth  As Long
  Dim lScaleHeight As Long
  
  If mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "180" Or mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "-180" Then
  
    frmAbout.RotatedRTB.Width = oPic.Width
    frmAbout.RotatedRTB.Height = oPic.Height
    lScaleWidth = frmPixbook.picDyn.ScaleWidth
    lScaleHeight = frmPixbook.picDyn.ScaleHeight
    
  Else '+/-90 or +/-270
  
    frmAbout.RotatedRTB.Width = oPic.Height
    frmAbout.RotatedRTB.Height = oPic.Width
    lScaleWidth = frmPixbook.picDyn.ScaleHeight
    lScaleHeight = frmPixbook.picDyn.ScaleWidth
    
  End If
  
  frmAbout.RotatedRTB.Text = mid(oPic.Tag, InStr(oPic.Tag, "#") + 1)
  frmAbout.RotatedRTB.SelStart = 0
  frmAbout.RotatedRTB.SelLength = 1
  frmAbout.RotatedRTB.Font.Size = oPic.Font.Size
  frmAbout.RotatedRTB.Font.Name = oPic.Font.Name
  frmAbout.RotatedRTB.Font.Bold = oPic.Font.Bold
  frmAbout.RotatedRTB.Font.Italic = oPic.Font.Italic
  frmAbout.RotatedRTB.Font.Underline = oPic.Font.Underline
  
  Dim bLarger As Boolean
  
  If frmPixbook.picDyn.ScaleWidth > oPic.Width Or frmPixbook.picDyn.ScaleHeight > oPic.Height Then bLarger = True '=> no limitations
  
  'First test on total TextHeight and TextWidth of first character:
  
  If bLarger Or (oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY And oPic.TextWidth(frmAbout.RotatedRTB.SelText) <= lScaleWidth / iTwX) Then
  
    Dim lPrevWidth  As Long
    Dim lPrevHeight As Long
    Dim hRegion     As Long
    
    lPrevWidth = oPic.Width
    lPrevHeight = oPic.Height
    oPic.Width = frmPixbook.picDyn.ScaleWidth
    oPic.Height = frmPixbook.picDyn.ScaleHeight
    
    'Changing the text width may affect total TextHeight => second test:
    
    If bLarger Or oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY Then
    
      hRegion = CreateRectRgn(0, 0, oPic.Width / iTwX, oPic.Height / iTwY)
      SetWindowRgn oPic.hWnd, hRegion, 1
      DeleteObject hRegion
      HandleResizedRotatedText = True
      
    Else
    
      oPic.Width = lPrevWidth
      oPic.Height = lPrevHeight
      
    End If
    
  End If
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedRotatedText", Erl
  Resume Next
  
End Function

Public Function HandleResizedRotatedTextFrame(ByRef oPic As PictureBox, ByRef oFrame As PictureBox) As Boolean

  On Error GoTo Error_Handler
  
  'Prepare frmAbout.RotatedRTB:
  
  Dim lScaleWidth  As Long
  Dim lScaleHeight As Long
  
  If mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "180" Or mid(oPic.Tag, InStr(oPic.Tag, "|") + 1, InStr(oPic.Tag, "#") - InStr(oPic.Tag, "|") - 1) = "-180" Then
  
    frmAbout.RotatedRTB.Width = oPic.Width
    frmAbout.RotatedRTB.Height = oPic.Height
    lScaleWidth = frmPixbook.picDyn.ScaleWidth
    lScaleHeight = frmPixbook.picDyn.ScaleHeight
    
  Else '+/-90 or +/-270
  
    frmAbout.RotatedRTB.Width = oPic.Height
    frmAbout.RotatedRTB.Height = oPic.Width
    lScaleWidth = frmPixbook.picDyn.ScaleHeight
    lScaleHeight = frmPixbook.picDyn.ScaleWidth
    
  End If
  
  frmAbout.RotatedRTB.Text = mid(oPic.Tag, InStr(oPic.Tag, "#") + 1)
  frmAbout.RotatedRTB.SelStart = 0
  frmAbout.RotatedRTB.SelLength = 1
  frmAbout.RotatedRTB.Font.Size = oPic.Font.Size
  frmAbout.RotatedRTB.Font.Name = oPic.Font.Name
  frmAbout.RotatedRTB.Font.Bold = oPic.Font.Bold
  frmAbout.RotatedRTB.Font.Italic = oPic.Font.Italic
  frmAbout.RotatedRTB.Font.Underline = oPic.Font.Underline
  
  Dim bLarger As Boolean
  
  If frmPixbook.picDyn.ScaleWidth > oFrame.Width Or frmPixbook.picDyn.ScaleHeight > oFrame.Height Then bLarger = True '=> no limitations
  
  'First test on total TextHeight and TextWidth of first character:
  
  If bLarger Or (oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY And oPic.TextWidth(frmAbout.RotatedRTB.SelText) <= lScaleWidth / iTwX) Then
  
    Dim lPrevWidth  As Long
    Dim lPrevHeight As Long
    Dim hRegion     As Long
    
    lPrevWidth = oPic.Width
    lPrevHeight = oPic.Height
    If oPic.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width > 0 Then oPic.Width = oPic.Width + frmPixbook.picDyn.ScaleWidth - oFrame.Width
    If oPic.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height > 0 Then oPic.Height = oPic.Height + frmPixbook.picDyn.ScaleHeight - oFrame.Height
    
    'Changing the text width may affect total TextHeight => second test:
    
    If bLarger Or oPic.TextHeight(frmAbout.RotatedRTB.SelText) * (1 + frmAbout.RotatedRTB.GetLineFromChar(Len(frmAbout.RotatedRTB.Text))) <= lScaleHeight / iTwY Then
    
      hRegion = CreateRectRgn(0, 0, oPic.Width / iTwX, oPic.Height / iTwY)
      SetWindowRgn oPic.hWnd, hRegion, 1
      DeleteObject hRegion
      If oFrame.Tag = "0" Then SetWindowRgn oFrame.hWnd, 0, 1
      HandleResizedRotatedTextFrame = True
      
    Else
    
      oPic.Width = lPrevWidth
      oPic.Height = lPrevHeight
      
    End If
    
  End If
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:HandleResizedRotatedTextFrame", Erl
  Resume Next
  
End Function

Private Function GetNumberOfCharsOnLastLine(ByRef RTB As RichTextBox) As Integer

  On Error GoTo Error_Handler
  
  Dim iPos As Integer 'Pointer position in RTB.Text
  Dim iLns As Integer 'Number of lines in RTB.Text
  
  iLns = RTB.GetLineFromChar(Len(RTB.Text))
  
  For iPos = 1 To Len(RTB.Text)
  
    If RTB.GetLineFromChar(iPos) = iLns Then GetNumberOfCharsOnLastLine = GetNumberOfCharsOnLastLine + 1
    
  Next
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:GetNumberOfCharsOnLastLine", Erl
  Resume Next
  
End Function

Private Function SmallerSoftReturnPositions(ByRef RTB As RichTextBox) As Boolean

  On Error GoTo Error_Handler
  
  Dim sTag As String
  Dim iPos As Integer
  
  sTag = frmAbout.RealSizeRTB.Tag
  
  For iPos = 1 To Len(RTB.Text) - 1
  
    If RTB.GetLineFromChar(iPos + 1) <> RTB.GetLineFromChar(iPos) Then
    
      If sTag = vbNullString Then
      
        SmallerSoftReturnPositions = True
        Exit For
        
      End If
      
      If CInt(Left(sTag, InStr(sTag, ",") - 1)) > iPos + 1 Then
      
        SmallerSoftReturnPositions = True
        Exit For
        
      End If
      
      sTag = mid(sTag, InStr(sTag, ",") + 1)
      
    End If
    
  Next
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modHandleText:SmallerSoftReturnPositions", Erl
  Resume Next
  
End Function
